## widelands 20

=== CMakeLists.txt ===
project (widelands)

cmake_minimum_required (VERSION 2.8.7)
cmake_policy(VERSION 2.8.7)

include("${CMAKE_SOURCE_DIR}/cmake/UseSystemInfo.cmake")

# This policy is not known to versions prior 3.1 and would result in errors,
# if set on such systems. This can be removed when cmake_minimum_required is set
# to 3.1 or newer by using:
# cmake_policy(VERSION 3.1)
if(POLICY CMP0054)
   cmake_policy(SET CMP0054 NEW)
endif(POLICY CMP0054)

# This policy is not known to versions prior 3.11 and would result in errors,
# if set on such systems. This can be removed when cmake_minimum_required is set
# to 3.11 or newer  by using:
# cmake_policy(VERSION 3.11)
if(POLICY CMP0072)
  cmake_policy(SET CMP0072 NEW)

  # TODO(stonerl): Check on later Ubuntu releases whether this workaround is
  # still needed or not.
  if (CMAKE_SYSTEM MATCHES "Linux")
    distro_name (DISTRO_NAME)
    # DISTRO_NAME is different on the build-servers.
    if ((DISTRO_NAME MATCHES "Ubuntu 18.10" OR DISTRO_NAME MATCHES "Cosmic"
         OR DISTRO_NAME MATCHES "Ubuntu 19.04" OR DISTRO_NAME MATCHES "Disco"
         OR DISTRO_NAME MATCHES "Ubuntu 19.10" OR DISTRO_NAME MATCHES "Eoan")
        AND CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
      cmake_policy(SET CMP0072 OLD)
    endif()
  endif()
endif(POLICY CMP0072)

# This policy is not known to versions prior 3.12 and would result in errors,
# if set on such systems. This can be removed when cmake_minimum_required is set
# to 3.12 or newer  by using:
# cmake_policy(VERSION 3.12)
if(POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW)
endif(POLICY CMP0074)

include("${CMAKE_SOURCE_DIR}/cmake/WlFunctions.cmake")

option(OPTION_USE_GLBINDING "Use glbinding instead of GLEW" OFF)
option(OPTION_GLEW_STATIC "Use static GLEW Library" OFF)
option(OPTION_BUILD_WEBSITE_TOOLS "Build website-related tools" ON)
option(OPTION_BUILD_TRANSLATIONS "Build translations" ON)

if (CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "Build directory and source directory must not be the same.")
endif (CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)

# Define the directory structure for installation - will be hardcoded in WL bin
# (through config.h). If not specified, we are going to use the directory where
# the executable is in. Also on Linux.
# Packagers (or people using make install) have to set this variable to an absolute path.
wl_set_if_unset(WL_INSTALL_BASEDIR ".")

# Define the directory structure for installation of the data files - will be hardcoded
# in WL bin (through config.h). If not specified, we are going to use the "data" directory
# below the directory where the executable is in. Also on Linux.
# Packagers (or people using make install) have to set this variable to an absolute path.
wl_set_if_unset(WL_INSTALL_DATADIR "./data")

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.8)
    message(FATAL_ERROR "Widelands needs GCC >= 4.8 to compile.")
  endif()
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.4)
    message(FATAL_ERROR "Clang version must be at least 3.4!")
  endif()
else()
  message(WARNING "You are using an unsupported compiler! Supported are Clang and GCC.")
endif()

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules)

if (WIN32)
  set (Boost_USE_STATIC_LIBS  ON)
  link_libraries(wsock32 ws2_32 bcrypt)
else()
  set (Boost_USE_STATIC_LIBS  OFF)
endif()
set (Boost_USE_MULTITHREADED ON)
set (Boost_DETAILED_FAILURE_MSG ON)
find_package(Boost 1.48
  COMPONENTS
    unit_test_framework
    regex
  REQUIRED
    system)

find_package (PythonInterp REQUIRED)

find_package(Gettext REQUIRED)
find_package(OpenGL REQUIRED)
find_package(PNG REQUIRED)
find_package(SDL2 REQUIRED)
find_package(SDL2_image REQUIRED)
find_package(SDL2_mixer REQUIRED)
find_package(SDL2_ttf REQUIRED)
find_package(ZLIB REQUIRED)
find_package(ICU REQUIRED)
if(OPTION_USE_GLBINDING)
  find_package(glbinding REQUIRED)
else()
  find_package(GLEW REQUIRED)
endif()

if (APPLE OR WIN32 OR
    CMAKE_SYSTEM_NAME MATCHES "FreeBSD" OR
    CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
  if (NOT CMAKE_SYSTEM_NAME MATCHES "kFreeBSD")
    find_package(intl REQUIRED)
  endif()
endif()

# Disable no symbols warning on macOS, but only on versions where this is
# supported. It is not supported on OS X 10.7 (DARWIN_MAJOR_VERSION == 11).
if (APPLE)
    if (${DARWIN_MAJOR_VERSION} GREATER 11)
        SET(CMAKE_C_ARCHIVE_CREATE   "<CMAKE_AR> Scr <TARGET> <LINK_FLAGS> <OBJECTS>")
        SET(CMAKE_CXX_ARCHIVE_CREATE "<CMAKE_AR> Scr <TARGET> <LINK_FLAGS> <OBJECTS>")
        SET(CMAKE_C_ARCHIVE_FINISH   "<CMAKE_RANLIB> -no_warning_for_no_symbols -c <TARGET>")
        SET(CMAKE_CXX_ARCHIVE_FINISH "<CMAKE_RANLIB> -no_warning_for_no_symbols -c <TARGET>")
    endif()
endif()

# TODO(sirver): One day, this should be enabled. Then we have no more cycles in our dependencies....
# set_property(GLOBAL PROPERTY GLOBAL_DEPENDS_NO_CYCLES ON)

if (NOT CMAKE_BUILD_TYPE OR CMAKE_BUILD_TYPE STREQUAL "")
  find_path(FILE_WL_RELEASE "WL_RELEASE" ${CMAKE_CURRENT_SOURCE_DIR})
  if(${FILE_WL_RELEASE} STREQUAL "FILE_WL_RELEASE-NOTFOUND")
    set(CMAKE_BUILD_TYPE Debug)
  else()
    set(CMAKE_BUILD_TYPE Release)
  endif()
endif (NOT CMAKE_BUILD_TYPE OR CMAKE_BUILD_TYPE STREQUAL "")

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(WL_DEBUG_FLAGS "-g -DDEBUG")
  option(OPTION_ASAN "Build with AddressSanitizer" ON)
elseif(CMAKE_BUILD_TYPE STREQUAL "Release")
  if(("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU") AND (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 6.2))
    message(STATUS "GCC >6.2.0 breaks -03, setting -02")
    set(WL_OPTIMIZE_FLAGS "-O2")
  else()
    set(WL_OPTIMIZE_FLAGS "-O3")
  endif ()
  set(WL_DEBUG_FLAGS "-DNDEBUG -DNOPARACHUTE")
  option(OPTION_ASAN "Build with AddressSanitizer" OFF)
elseif(CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
  if(("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU") AND (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 6.2))
    message(STATUS "GCC >6.2.0 breaks -03, setting -02")
    set(WL_OPTIMIZE_FLAGS "-O2")
  else()
    set(WL_OPTIMIZE_FLAGS "-O3")
  endif ()
  set(WL_DEBUG_FLAGS "-DNDEBUG -DNOPARACHUTE")
  option(OPTION_ASAN "Build with AddressSanitizer" ON)
else()
  message(FATAL_ERROR "Unknown CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
endif()

wl_add_flag(WL_GENERIC_CXX_FLAGS "-std=c++11")

if(OPTION_ASAN)
  message(STATUS "Using AddressSanitizer http://clang.llvm.org/docs/AddressSanitizer.html")
  # See http://clang.llvm.org/docs/AddressSanitizer.html
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-fsanitize=address")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-fno-omit-frame-pointer")
  set (CMAKE_EXE_LINKER_FLAGS "-fsanitize=address" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)
else()
  message(STATUS "Not using AddressSanitizer.")
endif(OPTION_ASAN)

# This is set to avoid linker errors when using GLVND-libs on Linux
if("${OpenGL_GL_PREFERENCE}" STREQUAL "GLVND")
   set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lGL")
   add_compile_definitions(WL_USE_GLVND)
   message(STATUS "Adding linker flags for GLVND.")
endif()

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Weverything")

  # Disabled warnings that are overly verbose right now or just do not make sense.
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wno-c++98-compat")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wno-c++98-compat-pedantic")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wno-conversion")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wno-exit-time-destructors")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wno-global-constructors")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wno-padded")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wno-sign-conversion")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wno-missing-noreturn")

  # It is impossible to write code that both GCC and Clang will like,
  # so we have to switch off the warning for one of them.
  # http://clang-developers.42468.n3.nabble.com/Question-on-Wswitch-enum-td4025927.html
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wno-switch-enum")

  # TODO(sirver): weak-vtables should be enabled, but leads to lot of errors right now.
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wno-weak-vtables")

  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wno-unreachable-code")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wno-documentation")

  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Werror=deprecated")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Werror=non-pod-varargs")

  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Qunused-arguments")

  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wint-to-void-pointer-cast")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 3.8)
      wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Winconsistent-missing-override")
  endif()
else()
  # Assuming GCC 4.8 or higher.
  if(WIN32)
    # This is needed for getenv().
    wl_add_flag(WL_GENERIC_CXX_FLAGS "-std=gnu++11")
  else()
    # SDL and MinGW both declare 'unsigned int __builtin_ia32_crc32qi(unsigned int, unsigned char)', resulting in lots of warnings. So, we can't have this flag in Windows.
    wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wredundant-decls")
  endif()

  # Because of: https://svn.boost.org/trac/boost/ticket/9240.
  wl_add_flag(WL_GENERIC_CXX_FLAGS "-fext-numeric-literals")

  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wall")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wpedantic")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wdeprecated-declarations")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wextra")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wformat")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wformat-nonliteral")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wformat-security")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wformat-y2k")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Winit-self")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Winvalid-pch")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wlogical-op")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wmissing-include-dirs")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wno-undef")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wold-style-cast")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Woverlength-strings")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wpacked")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wpointer-arith")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wsign-promo")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wsync-nand")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wtrampolines")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wundef")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wunused")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wunused-macros")
endif()


# Turn some warnings into errors.
wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Werror=format-security")
wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Werror=return-type")
wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Werror=shadow")
wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Werror=uninitialized")

IF (WIN32)
  add_definitions(-DMINGW_HAS_SECURE_API -DWIN32_LEAN_AND_MEAN -D__STDC_FORMAT_MACROS -D__USE_MINGW_ANSI_STDIO)
  if (CMAKE_SIZEOF_VOID_P EQUAL 4)
    set (CMAKE_EXE_LINKER_FLAGS "-Wl,--large-address-aware" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)
    message (STATUS "Enabled large address awareness on mingw32")
  else (CMAKE_SIZEOF_VOID_P EQUAL 4)
    message (STATUS "Detected mingw32-w64")
  endif (CMAKE_SIZEOF_VOID_P EQUAL 4)
endif (WIN32)

# on BSD this must be explicitly linked
if (CMAKE_SYSTEM_NAME MATCHES "FreeBSD" OR CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
  # Not needed on Debian GNU/kFreeBSD..
  if (NOT CMAKE_SYSTEM_NAME MATCHES "kFreeBSD")
    find_library(EXECINFO_LIBRARY NAMES execinfo)
  endif (NOT CMAKE_SYSTEM_NAME MATCHES "kFreeBSD")

  # OpenBSD needs the X11 include directory in order to find GL/glu.h
  if (CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
    find_package(X11 REQUIRED)
    include_directories(${X11_INCLUDE_DIR})
  endif ()
endif (CMAKE_SYSTEM_NAME MATCHES "FreeBSD" OR CMAKE_SYSTEM_NAME MATCHES "OpenBSD")

if (NOT DEFINED WL_VERSION)
  include (${CMAKE_SOURCE_DIR}/cmake/BzrRevision.cmake)
else (NOT DEFINED WL_VERSION)
  add_custom_target (
    InputRevision ALL

=== po/CMakeLists.txt ===
add_custom_target (
    lang ALL
)

macro(CreateLocale locale_name)
  set (commands "")
  file (GLOB_RECURSE pofiles *.po)
  foreach (pofile ${pofiles})
    get_filename_component(pofile_name ${pofile} NAME_WE)
    string(REPLACE "${CMAKE_CURRENT_SOURCE_DIR}/" "" pofile_subpath ${pofile})
    get_filename_component(pofile_path ${pofile} PATH)
    string(REPLACE "${CMAKE_CURRENT_SOURCE_DIR}/" "" template_name ${pofile_path})
    if (${pofile_name} STREQUAL ${locale_name})
      add_custom_command (
	OUTPUT ${CMAKE_BINARY_DIR}/locale/${locale_name}/LC_MESSAGES/${template_name}.mo
	COMMAND cmake -E make_directory ${CMAKE_BINARY_DIR}/locale/${locale_name}/LC_MESSAGES
	COMMAND msgmerge -q --no-wrap ${pofile} ${CMAKE_CURRENT_SOURCE_DIR}/${template_name}/${template_name}.pot -o ${CMAKE_CURRENT_BINARY_DIR}/${locale_name}_${template_name}.tmp.po
	COMMAND msgfmt -o ${CMAKE_BINARY_DIR}/locale/${locale_name}/LC_MESSAGES/${template_name}.mo ${CMAKE_CURRENT_BINARY_DIR}/${locale_name}_${template_name}.tmp.po
	COMMAND cmake -E remove ${CMAKE_CURRENT_BINARY_DIR}/${locale_name}_${template_name}.tmp.po
        DEPENDS ${pofile}
        COMMENT "Generating translations for locale ${locale_name} category ${template_name}"
      )
      list(APPEND commands ${CMAKE_BINARY_DIR}/locale/${locale_name}/LC_MESSAGES/${template_name}.mo)
    endif (${pofile_name} STREQUAL ${locale_name})
  endforeach (pofile ${pofiles})
  add_custom_target (
    translang_${locale_name}
    DEPENDS ${commands}
  )
  add_custom_target (
    lang_${locale_name}
    COMMAND cmake -Dlang=${locale_name} -Dpobasedir=${CMAKE_CURRENT_SOURCE_DIR} -Dlocalebasedir=${CMAKE_BINARY_DIR}/locale -P ${CMAKE_CURRENT_SOURCE_DIR}/CheckLocale.cmake
    COMMENT "Checking translations for locale ${locale_name}"
  )
  add_dependencies(lang lang_${locale_name})
  add_dependencies(lang_${locale_name} translang_${locale_name})
endmacro(CreateLocale locale_name)

set (languages_found "")
file (GLOB_RECURSE pofiles *.po)
foreach(pofile ${pofiles})
  get_filename_component(pofile ${pofile} NAME_WE)
  list(APPEND languages_found ${pofile})
endforeach(pofile ${pofiles})

list(SORT languages_found)
list(REMOVE_DUPLICATES languages_found)

foreach(language ${languages_found})
  CreateLocale(${language})
endforeach(language ${languages_found})

=== src/CMakeLists.txt ===
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/build_info.cc.cmake ${CMAKE_CURRENT_BINARY_DIR}/build_info.cc)

# Catchall target to codecheck all files.
add_custom_target(codecheck)
add_custom_target(run_build_deps
  COMMAND
    ${PYTHON_EXECUTABLE}
    ${CMAKE_SOURCE_DIR}/utils/build_deps.py
  COMMENT "Checking CMakeLists.txt files."
)
add_dependencies(codecheck run_build_deps)

# A target that depends on all unit tests as 'make test' will not rebuild
# tests:
# http://stackoverflow.com/questions/733475/cmake-ctest-make-test-doesnt-build-tests
add_custom_target(wl_tests)

#include the cmake version dependend macro _include_directories
if (CMAKE_VERSION VERSION_LESS 2.8.11)
  include (${CMAKE_SOURCE_DIR}/cmake/IncludeDirectoriesOld.cmake)
else (CMAKE_VERSION VERSION_LESS 2.8.11)
  include (${CMAKE_SOURCE_DIR}/cmake/IncludeDirectories.cmake)
endif (CMAKE_VERSION VERSION_LESS 2.8.11)

wl_library(build_info
  SRCS
    build_info.cc
    build_info.h
)

if (WIN32)
	configure_file (${CMAKE_CURRENT_SOURCE_DIR}/../utils/win32/widelands.rc.cmake ${CMAKE_CURRENT_BINARY_DIR}/widelands.rc)
	message (STATUS "Configured windows resource file")
	set(WIN32_ICON_O ${CMAKE_CURRENT_BINARY_DIR}/wl_icon.o)
	ADD_CUSTOM_COMMAND(OUTPUT ${WIN32_ICON_O}
		COMMAND ${MINGW_PREFIX}windres
			-o${WIN32_ICON_O}
			-i${CMAKE_CURRENT_BINARY_DIR}/widelands.rc
  )
  wl_binary(widelands
    WIN32
    SRCS
      main.cc
      ${WIN32_ICON_O}
    USES_SDL2
    DEPENDS
      base_exceptions
      widelands_ball_of_mud
      build_info
  )
else()
  wl_binary(widelands
    SRCS
      main.cc
    USES_SDL2
    DEPENDS
      base_exceptions
      widelands_ball_of_mud
      build_info
  )
endif()

add_subdirectory(ai)
add_subdirectory(base)
add_subdirectory(chat)
add_subdirectory(economy)
add_subdirectory(editor)
add_subdirectory(game_io)
add_subdirectory(graphic)
add_subdirectory(io)
add_subdirectory(logic)
add_subdirectory(map_io)
add_subdirectory(network)
add_subdirectory(notifications)
add_subdirectory(profile)
add_subdirectory(random)
add_subdirectory(scripting)
add_subdirectory(sound)
add_subdirectory(third_party)
add_subdirectory(ui_basic)
add_subdirectory(ui_fsmenu)
if (OPTION_BUILD_WEBSITE_TOOLS)
  add_subdirectory(website)
endif (OPTION_BUILD_WEBSITE_TOOLS)
add_subdirectory(wui)

# TODO(unknown): Ideally widelands_ball_of_mud shouldn't exist, everything should be in a
# library.
wl_library(widelands_ball_of_mud
  SRCS
    wlapplication.cc
    wlapplication.h
    wlapplication_messages.cc
    wlapplication_messages.h
  USES_SDL2
  USES_SDL2_IMAGE
  USES_SDL2_TTF
  DEPENDS
    base_exceptions
    base_geometry
    base_i18n
    base_log
    base_time_string
    build_info
    editor
    graphic
    graphic_fonthandler
    graphic_text
    graphic_text_constants
    helper
    io_filesystem
    logic
    logic_exceptions
    logic_filesystem_constants
    logic_game_controller
    logic_game_settings
    logic_single_player_game_settings
    map_io_map_loader
    network
    profile
    random
    sound
    ui_basic
    ui_fsmenu_gameloading
    ui_fsmenu_loading_common
    ui_fsmenu_main
    ui_fsmenu_maploading
    ui_fsmenu_misc
    ui_fsmenu_network
    ui_fsmenu_options
    wui
)

# TODO(sirver): Split into libs with useful names.
wl_library(helper
  SRCS
    helper.cc
    helper.h
  USES_SDL2
  DEPENDS
    base_exceptions
)

if (CMAKE_SYSTEM_NAME MATCHES "FreeBSD" OR CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
  target_link_libraries(widelands_ball_of_mud ${EXECINFO_LIBRARY})
endif (CMAKE_SYSTEM_NAME MATCHES "FreeBSD" OR CMAKE_SYSTEM_NAME MATCHES "OpenBSD")

if (WIN32)
  target_link_libraries(widelands_ball_of_mud wsock32)
endif (WIN32)

=== src/ai/CMakeLists.txt ===
wl_library(ai
  SRCS
    ai_help_structs.cc
    ai_help_structs.h
    ai_hints.cc
    ai_hints.h
    computer_player.cc
    computer_player.h
    defaultai_seafaring.cc
    defaultai_warfare.cc
    defaultai.cc
    defaultai.h
  DEPENDS
    base_exceptions
    base_i18n
    base_log
    base_macros
    base_time_string
    economy
    logic
    logic_constants
    scripting_lua_table
)

=== src/base/CMakeLists.txt ===
wl_library(base_macros
  SRCS
    macros.h
    macros.cc
)

wl_library(base_log
  SRCS
    log.cc
    log.h
  USES_SDL2
  DEPENDS
    base_macros
    base_exceptions
    build_info
)

wl_library(base_exceptions
  SRCS
    exceptions.cc
    warning.h
    wexception.h
  DEPENDS
    base_macros
)

wl_library(base_i18n
  SRCS
    i18n.h
    i18n.cc
  USES_INTL
  DEPENDS
    base_log
    base_macros
    third_party_gettext
)

wl_library(base_utf8
  SRCS
    utf8.h
    utf8.cc
)

wl_library(base_geometry
  SRCS
    rect.h
    vector.h
    vector.cc
)

wl_library(base_md5
  SRCS
    md5.cc
    md5.h
  DEPENDS
    base_macros
)

wl_library(base_scoped_timer
  SRCS
    scoped_timer.h
    scoped_timer.cc
  USES_SDL2
  DEPENDS
    base_log
    base_macros
)

wl_library(base_time_string
  SRCS
    time_string.h
    time_string.cc
  DEPENDS
    base_i18n
)

wl_library(base_math
  SRCS
    math.h
    math.cc
  DEPENDS
    base_macros
)

=== src/chat/CMakeLists.txt ===
wl_library(chat
  SRCS
    chat.h
    chat.cc
  DEPENDS
    logic_constants
    notifications
)

=== src/economy/CMakeLists.txt ===
wl_library(economy
  SRCS
    cmd_call_economy_balance.cc
    cmd_call_economy_balance.h
    economy.cc
    economy.h
    economy_data_packet.cc
    economy_data_packet.h
    expedition_bootstrap.cc
    expedition_bootstrap.h
    flag.cc
    flag.h
    fleet.cc
    fleet.h
    idleworkersupply.cc
    idleworkersupply.h
    iroute.h
    itransport_cost_calculator.h
    portdock.cc
    portdock.h
    request.cc
    request.h
    road.cc
    road.h
    route.cc
    route.h
    routeastar.cc
    routeastar.h
    router.cc
    router.h
    routing_node.h
    shippingitem.cc
    shippingitem.h
    supply.h
    supply_list.cc
    supply_list.h
    trackptr.h
    transfer.cc
    transfer.h
    ware_instance.cc
    ware_instance.h
    warehousesupply.h
    input_queue.cc
    input_queue.h
    wares_queue.cc
    wares_queue.h
    workers_queue.cc
    workers_queue.h
  DEPENDS
    base_exceptions
    base_log
    base_macros
    io_fileread
    logic
    logic_constants
    logic_exceptions
    logic_widelands_geometry
    map_io
    notifications
)
add_subdirectory(test)

=== src/editor/CMakeLists.txt ===
wl_library(editor
  SRCS
    editorinteractive.cc
    editorinteractive.h
    map_generator.cc
    map_generator.h
    tools/action_args.h
    tools/decrease_height_tool.cc
    tools/decrease_height_tool.h
    tools/decrease_resources_tool.cc
    tools/decrease_resources_tool.h
    tools/delete_critter_tool.cc
    tools/delete_critter_tool.h
    tools/delete_immovable_tool.cc
    tools/delete_immovable_tool.h
    tools/draw_tool.cc
    tools/draw_tool.h
    tools/history.cc
    tools/history.h
    tools/increase_height_tool.cc
    tools/increase_height_tool.h
    tools/increase_resources_tool.cc
    tools/increase_resources_tool.h
    tools/info_tool.cc
    tools/info_tool.h
    tools/multi_select.h
    tools/noise_height_tool.cc
    tools/noise_height_tool.h
    tools/place_critter_tool.cc
    tools/place_critter_tool.h
    tools/place_immovable_tool.cc
    tools/place_immovable_tool.h
    tools/set_height_tool.cc
    tools/set_height_tool.h
    tools/set_origin_tool.cc
    tools/set_origin_tool.h
    tools/set_port_space_tool.cc
    tools/set_port_space_tool.h
    tools/set_resources_tool.cc
    tools/set_resources_tool.h
    tools/set_starting_pos_tool.cc
    tools/set_starting_pos_tool.h
    tools/set_terrain_tool.cc
    tools/set_terrain_tool.h
    tools/tool.h
    tools/tool_action.h
    ui_menus/categorized_item_selection_menu.h
    ui_menus/help.cc
    ui_menus/help.h
    ui_menus/main_menu.cc
    ui_menus/main_menu.h
    ui_menus/main_menu_load_map.cc
    ui_menus/main_menu_load_map.h
    ui_menus/main_menu_load_or_save_map.cc
    ui_menus/main_menu_load_or_save_map.h
    ui_menus/main_menu_map_options.cc
    ui_menus/main_menu_map_options.h
    ui_menus/main_menu_new_map.cc
    ui_menus/main_menu_new_map.h
    ui_menus/main_menu_random_map.cc
    ui_menus/main_menu_random_map.h
    ui_menus/main_menu_save_map.cc
    ui_menus/main_menu_save_map.h
    ui_menus/main_menu_save_map_make_directory.cc
    ui_menus/main_menu_save_map_make_directory.h
    ui_menus/player_menu.cc
    ui_menus/player_menu.h
    ui_menus/tool_change_height_options_menu.cc
    ui_menus/tool_change_height_options_menu.h
    ui_menus/tool_change_resources_options_menu.cc
    ui_menus/tool_change_resources_options_menu.h
    ui_menus/tool_menu.cc
    ui_menus/tool_menu.h
    ui_menus/tool_noise_height_options_menu.cc
    ui_menus/tool_noise_height_options_menu.h
    ui_menus/tool_options_menu.cc
    ui_menus/tool_options_menu.h
    ui_menus/tool_place_critter_options_menu.cc
    ui_menus/tool_place_critter_options_menu.h
    ui_menus/tool_place_immovable_options_menu.cc
    ui_menus/tool_place_immovable_options_menu.h
    ui_menus/tool_set_terrain_options_menu.cc
    ui_menus/tool_set_terrain_options_menu.h
    ui_menus/toolsize_menu.cc
    ui_menus/toolsize_menu.h
  USES_SDL2
  DEPENDS
    base_exceptions
    base_i18n
    base_log
    base_macros
    base_scoped_timer
    graphic
    graphic_fonthandler
    graphic_playercolor
    graphic_surface
    graphic_text_layout
    io_filesystem
    logic
    logic_constants
    logic_filesystem_constants
    logic_generic_save_handler
    logic_tribe_basic_info
    logic_widelands_geometry
    map_io
    map_io_map_loader
    notifications
    profile
    random
    scripting_coroutine
    scripting_lua_interface
    scripting_lua_table
    ui_basic
    wui
    wui_common_mapdetails
    wui_mapview_pixelfunctions
)

=== src/game_io/CMakeLists.txt ===
wl_library(game_io
  SRCS
    game_cmd_queue_packet.cc
    game_cmd_queue_packet.h
    game_data_packet.h
    game_class_packet.cc
    game_class_packet.h
    game_interactive_player_packet.cc
    game_interactive_player_packet.h
    game_player_ai_persistent_packet.cc
    game_player_ai_persistent_packet.h
    game_loader.cc
    game_loader.h
    game_map_packet.cc
    game_map_packet.h
    game_player_economies_packet.cc
    game_player_economies_packet.h
    game_player_info_packet.cc
    game_player_info_packet.h
    game_preload_packet.cc
    game_preload_packet.h
    game_saver.cc
    game_saver.h
  DEPENDS
    base_exceptions
    base_log
    base_macros
    base_scoped_timer
    base_time_string
    build_info
    economy
    graphic_image_io
    graphic_minimap_renderer
    io_fileread
    io_filesystem
    logic
    logic_exceptions
    logic_game_controller
    map_io
    map_io_map_loader
    profile
    scripting_lua_interface
    scripting_lua_table
    wui
    wui_mapview_pixelfunctions
    wui_mapview
)

=== src/graphic/CMakeLists.txt ===
add_subdirectory(text)

# TODO(sirver): Separate this directory into a base directory and one
# that is Widelands aware (can include logic stuff).

# Align and color


wl_library(graphic_styles
  SRCS
    panel_styles.cc
    panel_styles.h
  DEPENDS
    graphic_color
    graphic_surface
)

wl_library(graphic_align
  SRCS
    align.h
    align.cc
)

wl_library(graphic_color
  SRCS
    color.h
    color.cc
  USES_SDL2
)

wl_library(graphic_playercolor
  SRCS
    playercolor.cc
    playercolor.h
  DEPENDS
    graphic
    graphic_color
    graphic_image_cache
    graphic_surface
    io_filesystem
)


# Rendering utils

wl_library(graphic_build_texture_atlas
  SRCS
    build_texture_atlas.h
    build_texture_atlas.cc
  DEPENDS
    graphic
    graphic_image_io
    graphic_surface
    graphic_texture_atlas
    io_filesystem
)

wl_library(graphic_image_io
  SRCS
    image_io.h
    image_io.cc
  USES_PNG
  USES_SDL2
  USES_SDL2_IMAGE
  DEPENDS
    base_exceptions
    base_log
    graphic_surface
    io_fileread
    io_filesystem
    io_stream
)

wl_library(graphic_image_cache
  SRCS
    image_cache.cc
    image_cache.h
  USES_SDL2
  DEPENDS
    base_macros
    graphic_image_io
    graphic_surface
    graphic_texture_atlas
)

wl_library(graphic_sdl_utils
  SRCS
    sdl_utils.h
    sdl_utils.cc
  USES_SDL2
)

wl_library(graphic_gl_utils
  SRCS
    gl/blit_data.h
    gl/coordinate_conversion.h
    gl/initialize.cc
    gl/initialize.h
    gl/system_headers.h
    gl/utils.cc
    gl/utils.h
  USES_SDL2
  USES_OPENGL
  DEPENDS
    base_exceptions
    base_geometry
    base_log
    base_macros
    io_fileread
    io_filesystem
)

wl_library(graphic_surface
  SRCS
    image.h
    screen.cc
    screen.h
    surface.cc
    surface.h
    texture.cc
    texture.h
  USES_SDL2
  DEPENDS
    base_exceptions
    base_geometry
    base_log
    base_macros
    graphic_color
    graphic_draw_programs
    graphic_gl_utils
    graphic_render_queue
    graphic_sdl_utils
)

wl_library(graphic_texture_atlas
  SRCS
    texture_atlas.h
    texture_atlas.cc
  DEPENDS
    base_exceptions
    base_macros
    graphic_surface
)

wl_library(graphic_draw_programs
  SRCS
    blend_mode.h
    blit_mode.h
    gl/blit_program.cc
    gl/blit_program.h
    gl/draw_line_program.cc
    gl/draw_line_program.h
    gl/fill_rect_program.cc
    gl/fill_rect_program.h
  DEPENDS
    base_exceptions
    base_macros
    base_geometry
    graphic_gl_utils
    base_log
    graphic_color
)


# Logic-aware stuff

wl_library(graphic_render_queue
  SRCS
    render_queue.cc
    render_queue.h
  DEPENDS
    base_exceptions
    base_geometry
    base_macros
    graphic_color
    graphic_draw_programs
    graphic_fields_to_draw
    graphic_terrain_programs
    logic
)

wl_library(graphic_game_renderer
  SRCS
    game_renderer.cc
    game_renderer.h
  DEPENDS
    base_geometry
    base_macros
    graphic
    graphic_fields_to_draw
    graphic_gl_utils
    graphic_render_queue
    graphic_surface
    logic
    wui
    wui_mapview_pixelfunctions
)

wl_library(graphic_minimap_renderer
  SRCS
    minimap_renderer.cc
    minimap_renderer.h
  DEPENDS
    base_geometry
    base_macros
    economy
    graphic_surface
    logic
    wui_mapview_pixelfunctions
)

wl_library(graphic_fields_to_draw
  SRCS
    gl/fields_to_draw.cc
    gl/fields_to_draw.h
  DEPENDS
    base_geometry
    graphic
    graphic_gl_utils
    logic
    logic_constants
    logic_widelands_geometry
    wui_mapview_pixelfunctions
)

wl_library(graphic_terrain_programs
  SRCS
    gl/road_program.cc
    gl/road_program.h
    gl/terrain_program.cc
    gl/terrain_program.h
    gl/dither_program.cc
    gl/dither_program.h
  DEPENDS
    base_exceptions
    base_geometry
    base_log
    base_macros
    graphic_fields_to_draw
    graphic_gl_utils
    graphic_image_io
    graphic_surface
    io_filesystem
    logic
)


# Font handler and text
wl_library(graphic_fonthandler
  SRCS
    font_handler.cc
    font_handler.h
  DEPENDS
    base_macros
    graphic_image_cache
    graphic_text
)

wl_library(graphic_text_constants
  SRCS
    text_constants.h
    text_constants.cc
)

wl_library(graphic_text_layout
  SRCS
    text_layout.cc
    text_layout.h
  DEPENDS
    graphic # TODO(Gunchleoc): For text_width safety only - rewrite that function
    graphic_align
    graphic_color
    graphic_surface
    graphic_text
    graphic_text_constants
    graphic_fonthandler
    graphic_styles
)

wl_library(graphic_wordwrap
  SRCS
    wordwrap.cc
    wordwrap.h
  USES_ICU
  USES_SDL2_TTF
  DEPENDS
    base_geometry
    base_log
    graphic
    graphic_align
    graphic_color
    graphic_fonthandler
    graphic_text
    graphic_text_constants
    graphic_text_layout
)


# Base library

wl_library(graphic
  SRCS
    animation.cc
    animation.h
    default_resolution.h
    diranimations.h
    graphic.cc
    graphic.h
    style_manager.cc
    style_manager.h
    rendertarget.cc
    rendertarget.h
  USES_SDL2
  DEPENDS
    base_exceptions
    base_geometry
    base_i18n
    base_log
    base_macros
    base_scoped_timer
    build_info
    graphic_align
    graphic_build_texture_atlas
    graphic_color
    graphic_draw_programs
    graphic_gl_utils
    graphic_image_cache
    graphic_image_io
    graphic_playercolor
    graphic_render_queue
    graphic_styles
    graphic_surface
    graphic_text_layout
    io_filesystem
    io_stream
    logic_constants
    note_sound
    notifications
    scripting_lua_interface
    scripting_lua_table
    sound
)

=== src/io/CMakeLists.txt ===
add_subdirectory(filesystem)

wl_library(io_stream
  SRCS
    machdep.h
    streamread.cc
    streamread.h
    streamwrite.cc
    streamwrite.h
  USES_SDL2
  DEPENDS
    base_exceptions
    base_macros
)

wl_library(io_fileread
  SRCS
    fileread.cc
    fileread.h
    filewrite.cc
    filewrite.h
  DEPENDS
    io_filesystem
    io_stream
)

=== src/logic/CMakeLists.txt ===
wl_library(logic_exceptions
  SRCS
    game_data_error.cc
    game_data_error.h
  DEPENDS
    base_exceptions
    base_i18n
)

wl_library(logic_widelands_geometry
  SRCS
    widelands_geometry.cc
    widelands_geometry.h
)

wl_library(logic_game_settings
  SRCS
    game_settings.cc
    game_settings.h
    player_end_result.h
  DEPENDS
    io_filesystem
    logic_constants
    logic_tribe_basic_info
    notifications
    scripting_lua_interface
    scripting_lua_table
)

wl_library(logic_single_player_game_settings
  SRCS
    single_player_game_settings_provider.cc
    single_player_game_settings_provider.h
  DEPENDS
    ai
    base_exceptions
    base_i18n
    logic_game_settings
    logic_tribe_basic_info
)

wl_library(logic_game_controller
  SRCS
    game_controller.h
    replay_game_controller.h
    replay_game_controller.cc
    single_player_game_controller.h
    single_player_game_controller.cc
  DEPENDS
    ai
    logic
    logic_constants
    logic_game_settings
    profile
    ui_basic
    wui
)

wl_library(logic_campaign_visibility
  SRCS
    campaign_visibility.cc
    campaign_visibility.h
  DEPENDS
    base_exceptions
    io_filesystem
    logic_filesystem_constants
    profile
)

wl_library(logic_constants
  SRCS
    widelands.cc
    widelands.h
  DEPENDS
    base_macros
)

wl_library(logic_filesystem_constants
  SRCS
    filesystem_constants.h
    filesystem_constants.cc
)

wl_library(logic_tribe_basic_info
  SRCS
    map_objects/tribes/tribe_basic_info.cc
    map_objects/tribes/tribe_basic_info.h
  DEPENDS
    base_i18n
    logic_exceptions
    scripting_lua_table
    scripting_lua_interface

)

wl_library(logic_generic_save_handler
  SRCS
    generic_save_handler.h
    generic_save_handler.cc
  DEPENDS
    base_i18n
    base_log
    base_time_string
    io_filesystem
    logic_filesystem_constants
)

wl_library(logic
  SRCS
    ai_dna_handler.cc
    ai_dna_handler.h
    backtrace.cc
    backtrace.h
    cmd_calculate_statistics.cc
    cmd_calculate_statistics.h
    cmd_delete_message.cc
    cmd_delete_message.h
    cmd_incorporate.cc
    cmd_incorporate.h
    cmd_luacoroutine.cc
    cmd_luacoroutine.h
    cmd_luascript.cc
    cmd_luascript.h
    cmd_queue.cc
    cmd_queue.h
    cookie_priority_queue.h
    description_maintainer.h
    editor_game_base.cc
    editor_game_base.h
    field.cc
    field.h
    findbob.cc
    findbob.h
    findimmovable.cc
    findimmovable.h
    findnode.cc
    findnode.h
    game.cc
    game.h
    map.cc
    map.h
    map_revision.cc
    map_revision.h
    mapastar.cc
    mapastar.h
    mapdifferenceregion.cc
    mapdifferenceregion.h
    mapfringeregion.cc
    mapfringeregion.h
    maphollowregion.cc
    maphollowregion.h
    mapregion.h
    maptriangleregion.cc
    maptriangleregion.h
    message.h
    message_id.h
    message_queue.h
    nodecaps.h
    objective.h
    path.cc
    path.h
    pathfield.cc
    pathfield.h
    player.cc
    player.h
    player_area.h
    playercommand.cc
    playercommand.h
    playersmanager.cc
    playersmanager.h
    queue_cmd_factory.cc
    queue_cmd_factory.h
    queue_cmd_ids.h
    replay.cc
    replay.h
    roadtype.h
    save_handler.cc
    save_handler.h
    see_unsee_node.h
    trade_agreement.h
    widelands_geometry_io.cc
    widelands_geometry_io.h
    map_objects/bob.cc
    map_objects/bob.h
    map_objects/buildcost.cc
    map_objects/buildcost.h
    map_objects/checkstep.cc
    map_objects/checkstep.h
    map_objects/draw_text.h
    map_objects/immovable.cc
    map_objects/immovable.h
    map_objects/immovable_program.h
    map_objects/map_object.cc
    map_objects/map_object.h
    map_objects/terrain_affinity.cc
    map_objects/terrain_affinity.h
    map_objects/tribes/attack_target.h
    map_objects/tribes/battle.cc
    map_objects/tribes/battle.h
    map_objects/tribes/bill_of_materials.h
    map_objects/tribes/building.cc
    map_objects/tribes/building.h
    map_objects/tribes/carrier.cc
    map_objects/tribes/carrier.h
    map_objects/tribes/constructionsite.cc
    map_objects/tribes/constructionsite.h
    map_objects/tribes/dismantlesite.cc
    map_objects/tribes/dismantlesite.h
    map_objects/tribes/market.cc
    map_objects/tribes/market.h
    map_objects/tribes/militarysite.cc
    map_objects/tribes/militarysite.h
    map_objects/tribes/partially_finished_building.cc
    map_objects/tribes/partially_finished_building.h
    map_objects/tribes/production_program.cc
    map_objects/tribes/production_program.h
    map_objects/tribes/productionsite.cc
    map_objects/tribes/productionsite.h
    map_objects/tribes/program_result.h
    map_objects/tribes/requirements.cc
    map_objects/tribes/requirements.h
    map_objects/tribes/road_textures.cc
    map_objects/tribes/road_textures.h
    map_objects/tribes/ship.cc
    map_objects/tribes/ship.h
    map_objects/tribes/soldier.cc
    map_objects/tribes/soldier.h
    map_objects/tribes/soldiercontrol.h
    map_objects/tribes/training_attribute.h
    map_objects/tribes/trainingsite.cc
    map_objects/tribes/trainingsite.h
    map_objects/tribes/tribe_descr.cc
    map_objects/tribes/tribe_descr.h
    map_objects/tribes/tribes.cc
    map_objects/tribes/tribes.h
    map_objects/tribes/ware_descr.cc
    map_objects/tribes/ware_descr.h
    map_objects/tribes/warehouse.cc
    map_objects/tribes/warehouse.h
    map_objects/tribes/warelist.cc
    map_objects/tribes/warelist.h
    map_objects/tribes/wareworker.h
    map_objects/tribes/workarea_info.h
    map_objects/tribes/worker.cc
    map_objects/tribes/worker.h
    map_objects/tribes/worker_descr.cc
    map_objects/tribes/worker_descr.h
    map_objects/tribes/worker_program.cc
    map_objects/tribes/worker_program.h
    map_objects/walkingdir.cc
    map_objects/walkingdir.h
    map_objects/world/critter.cc
    map_objects/world/critter.h
    map_objects/world/critter_program.h
    map_objects/world/editor_category.cc
    map_objects/world/editor_category.h
    map_objects/world/map_gen.cc
    map_objects/world/map_gen.h
    map_objects/world/resource_description.cc
    map_objects/world/resource_description.h
    map_objects/world/terrain_description.cc
    map_objects/world/terrain_description.h
    map_objects/world/world.cc
    map_objects/world/world.h
  # TODO(sirver): Uses SDL2 only on WIN32 for a dirty hack.
  USES_SDL2
  DEPENDS
    ai
    base_exceptions
    base_geometry
    base_i18n
    base_log
    base_macros
    base_math
    base_md5
    base_scoped_timer
    base_time_string
    build_info
    economy
    game_io
    graphic
    graphic_color
    graphic_fonthandler
    graphic_image_io
    graphic_playercolor
    graphic_surface
    graphic_text_constants
    graphic_text_layout
    helper
    io_fileread
    io_filesystem
    io_stream
    logic_constants
    logic_exceptions
    logic_filesystem_constants
    logic_game_controller
    logic_game_settings
    logic_generic_save_handler
    logic_tribe_basic_info
    logic_widelands_geometry
    map_io
    map_io_map_loader
    network
    note_sound
    notifications
    profile
    random
    scripting_coroutine
    scripting_logic
    scripting_lua_interface
    scripting_lua_table
    sound
    ui_basic
    wui
    wui_mapview_pixelfunctions
)

=== debian/changelog ===
widelands (1:20-2build2) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Mar 2020 09:31:37 +0100

widelands (1:20-2build1) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:25:56 +0100

=== debian/control ===
Source: widelands
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
  Martin Quinson <mquinson@debian.org>,
  Enrico Tassi <gareuselesinge@debian.org>,
Standards-Version: 4.5.0
Build-Depends: debhelper-compat (= 12),
  cmake,
  libminizip-dev,
  libboost-dev,
  libboost-regex-dev,
  libboost-test-dev,
  libboost-system-dev,
  libglew-dev,
  libpng-dev,
  libsdl2-dev,
  libsdl2-image-dev,
  libsdl2-mixer-dev,
  libsdl2-ttf-dev,
  python3,
  zlib1g-dev
Vcs-Git: https://salsa.debian.org/games-team/widelands.git
Vcs-Browser: https://salsa.debian.org/games-team/widelands
Homepage: http://www.widelands.org/
Rules-Requires-Root: no

Package: widelands
Architecture: any
Depends: widelands-data (= ${source:Version}),
  ${shlibs:Depends},
  ${misc:Depends},
Description: fantasy real-time strategy game
 Widelands is a strategy game aiming for gameplay similar to Settlers II by
 BlueByte.
 .
 In this game, you start out on a small piece of land with nothing more than
 a few of useful resources. Using those, you can build yourself an empire
 with many thousands of inhabitants. On your way towards this goal, you will
 have to build up an economic infrastructure, explore the lands around you
 and face enemies who are trying to rule the world just like you do.

Package: widelands-data
Architecture: all
Depends: fonts-freefont-ttf,
  fonts-dejavu-core,
  fonts-dejavu-extra,
  fonts-hosny-amiri,
  fonts-lklug-sinhala,
  fonts-nakula,
  fonts-wqy-microhei,
  ${misc:Depends}
Description: fantasy real-time strategy game (data files)
 This package contains the graphics and levels for Widelands.
 .
 Widelands is a strategy game aiming for gameplay similar to Settlers II by
 BlueByte.
 .
 In this game, you start out on a small piece of land with nothing more than
 a few of useful resources. Using those, you can build yourself an empire
 with many thousands of inhabitants. On your way towards this goal, you will
 have to build up an economic infrastructure, explore the lands around you
 and face enemies who are trying to rule the world just like you do.

=== debian/rules ===
#!/usr/bin/make -f

# Hardening flags
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@ $(DH_ARGS) --buildsystem=cmake


override_dh_auto_configure:
	CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" CPPFLAGS="$(CPPFLAGS)" CXXFLAGS="$(CXXFLAGS)" \
	  dh_auto_configure -Scmake -- \
		-DWL_INSTALL_BASEDIR=/usr/share/games/widelands \
		-DWL_INSTALL_BINDIR=games \
		-DWL_INSTALL_DATADIR=/usr/share/games/widelands/data \
		-DWL_INSTALL_PREFIX=/usr \
		-DOPTION_BUILD_WEBSITE_TOOLS=OFF \
		-DCMAKE_BUILD_TYPE=Release

override_dh_auto_install:
	dh_auto_install --parallel
	mkdir -p  debian/tmp/usr/share/applications/
	cp debian/org.widelands.widelands.desktop debian/tmp/usr/share/applications/
	# Take care of the fonts (use system-wide ones)
	# Not doing so would violate the Debian Policy, preventing the package to enter the official repositories
	ln -s /usr/share/fonts/opentype/fonts-hosny-amiri debian/tmp/usr/share/games/widelands/data/i18n/fonts/amiri
	ln -s /usr/share/fonts/truetype/dejavu debian/tmp/usr/share/games/widelands/data/i18n/fonts/DejaVu
	ln -s /usr/share/fonts/truetype/wqy debian/tmp/usr/share/games/widelands/data/i18n/fonts/MicroHei
	ln -s /usr/share/fonts/truetype/Nakula debian/tmp/usr/share/games/widelands/data/i18n/fonts
	ln -s /usr/share/fonts/truetype/sinhala debian/tmp/usr/share/games/widelands/data/i18n/fonts/Sinhala
	# Remove the licenses that are included in debian/copyright
	rm debian/tmp/usr/share/games/widelands/data/i18n/fonts/Culmus/LICENSE
	rm debian/tmp/usr/share/games/widelands/data/i18n/fonts/Widelands/LICENSE
	# The GPL-2 license is listed from the user interface, so dont kill it completely
	# (we cannot patch the user interface because that's in a translated text)
	if cmp --quiet debian/tmp/usr/share/games/widelands/COPYING /usr/share/common-licenses/GPL-2 ; then \
	  rm debian/tmp/usr/share/games/widelands/COPYING; \
	  cd debian/tmp/usr/share/games/widelands/ ; \
	  ln -s /usr/share/common-licenses/GPL-2 COPYING ; \
	else \
	  echo "Error: Licence file changed. Please check it out:"; \
	  diff -u debian/tmp/usr/share/games/widelands/COPYING /usr/share/common-licenses/GPL-2; \
	  exit 1; \
	fi
	# Take care of the logo
	for size in 16 32 48 64 128 ; do \
	  mkdir -p debian/tmp/usr/share/icons/hicolor/$${size}x$${size}/apps ; \
	  cp ./debian/tmp/usr/share/games/widelands/data/images/logos/wl-ico-$${size}.png \
	     debian/tmp/usr/share/icons/hicolor/$${size}x$${size}/apps/widelands.png; \
	done
	# Move the main binary to the right location (no idea why it's misplaced)
	mkdir debian/tmp/usr/games
	mv debian/tmp/usr/widelands debian/tmp/usr/games
	# appdata
	mkdir -p debian/tmp/usr/share/metainfo/
	cp debian/widelands.appdata.xml debian/tmp/usr/share/metainfo/

override_dh_missing:
	dh_missing --fail-missing

=== debian/watch ===
# test this watch file using:
# uscan --watchfile debian/watch --upstream-version 0.0.1 --package widelands
#
version=4
opts="uversionmangle=s/-rc/~rc/,dversionmangle=s/^1://" \
https://launchpad.net/widelands/+download \
https://launchpad.net/widelands/.*/widelands-(?:b[[:alpha:]]*)?(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
